# Mysticons - Sprint08

## Suunnittelu

WIMMA Labin lähetessä loppuaan on aika aloittaa dokumentaation suunnittelu. Kaikesta kesän 2021 aikana selvitetystä ja ratkaistuista asioista koostetaan ainakin englanninkielinen dokumentaatio ajatuksella ”for dummies”. Tämä tarkoittaa, että dokumentaatio kirjoitetaan siten, että Power Automatesta tai Kuberneteksesta/GitLabista/tms ei tarvitse olla aiempaa tietämystä, jotta pystyy dokumentaation ja ohjeistuksen avulla pääsemään samaan tilanteeseen. Dokumentaation pohjatyössä hyödynnetään toisille tiimeille pidettyjä ohjaus- ja esittelytilaisuuksia, sekä tilaisuuksissa esiin tulleita kysymyksiä. Muutenkin dokumentaatiossa pyritään selkeyteen ja havainnollisuuteen. Asiat pyritään avaamaan niin, että asioista tajuaa oleellisen ratkaisujen toimivuuden tarpeiksi ja sikäli, mikäli lisätietoa haluaa, niin sitä osaa lähteä dokumentaation pohjalta hakemaan. Dokumentoidut ratkaisut pyritään tekemään perusosiltaan valmiiksi kokonaisuuksiksi, joita on sitten helppo lähteä laajentamaan tulevaisuudessa. 

 

Maanantaina Power Automatesta pidetään koko WIMMA Labille esittely, josta kerätään materiaalia ja kokemusta paitsi dokumentaatioon, myös Mysticonsin somepostaus vastuuviikolle. Tämä osuu sprint09lle, joten sprint08n aikana on hyvä tehdä jo valmisteluja, jotta postauksia saataisiin viikon aikana julkaistua sekä Power Automatesta, että Kube hommista. Postauksia, olisi hyvä myös saada julkaistua enemmän kuin yksi/viikko. Ja muuna ajankohtana kuin perjantai iltapäivänä. Näin sekä WIMMA Labille, että Mysticonsille ja muille tiimeille saataisiin kesän lopussa enemmän näkyvyyttä. 

 

Power Automaten osalta perustoiminnallisuudet alkavat olla valmiita. Joitakin ominaisuuksia on vielä selvityksessä, että saataisiinko niihin liittyvät haasteet ratkaistua, vai pitääkö niistä koostaa dokumentaatio siihen saakka kuin nyt on päästy ja jättää ratkaisu keskeneräiseksi. Kaikkea ei annetussa aikaikkunassa ole mahdollista saada valmiiksi, ja tiimin kesken nähdään, että dokumentaatioon on hyvä panostaa, jotta tehdystä työstä saisi kaikista parhaimman hyödyn irti tulevaisuudessa, eikä kaikki kosahtaisi hutiloidusti tehtyyn dokumentaatioon.  

 

Kuberneteksessa selvitettävää olisi vielä paljon ja Kube tuleekin jäämään Power Automatea keskeneräisemmäksi aiheen laajuuden takia. Kaikkiaan Kuben peruspohja on aika toimiva ja kehitetyn mallin avulla palvelut saa pyörähtämään Kuben päälle aika vaivattomasti. Koventamista on päästy aloittamaan, ja sitä pyritään jatkamaan samoin periaattein kuin Power Automatea. Todennäköisesti Kuben VLE integraation selvittämiseen ei tule riittämään aikaa, eikä kaikkia tietoturva-asioita saada selville, mutta kokonaisuutena Kubernetes pyritään saattamaan vaiheeseen, joka on hyvin dokumentoitu ja joka on hyvä pohjatyö seuraaville. Sprintin aikana pyritään osaltaan valmistautumaan dokumentaatioon päivittämällä tietoja arkkitehtuurista ja specseistä. 

 

Sprintillä jatkuvat lisäksi Robot Framework ja testaushommat, sekä Kuberneteksen osien kehittäminen, kuten namespacejen eristäminen. Tarvittaessa Mysticons on valmiina myös auttamaan muita tiimejä. Overflown kanssa katsotaan loppuun heidän Kuben pystytys ja debloymentti, että selviää, mikä meni vikaan perjantaina ja onko ongelma saatu pysyvästi ratkaistua. 

#### Esimerkkejä sprintin taskeista:

- Power Automate: Pidä esittely WIMMA Labille 

- Päivitä ”hardware architecture” 

- Päivitä arkkitehtuuri ja tekniset ratkaisut 

- PA & Kube valmistaudu dokumentaatioon 


## Arvio sprintin taskien 

Sprintin aikana saatiin ratkottua osa sprintille suunnitelluista taskeista. Aikaa meni toki yllättäviinkin taskeihin, mutta kaikki edistivät projektia osaltaan. Yllätykset ja helle, kuitenkin vaikuttivat osaltaan siihen, että tältä sprintiltä jouduttiin siirtämään ja jatkamaan sprintille suunniteltuja taskeja seuraavalle sprintille tavallista enemmän. Onneksi osa taskeista oli suunniteltukin niin, että ne jakautuisivat useamman sprintin ajalle. Kuitenkin osa taskeista oli suunniteltu tätä sprinttiä silmällä pitäen. Todennäköisesti taskien siirtyminen ei haittaa, sillä kyseiset taskit olivat suhteellisen pieniä ja niitten suorittaminen ei vie paljoa aikaa, mutta yllätystaskit ja muut taskit joihin tällä sprintillä keskityttiin, olivat painoarvoltaan näitä, siirrettyjä taskeja, isompia. Nämä päivitys taskit saadaan luultavammin suoritettua alta heti seuraavan sprintin alussa. 

## Review

Kuten mainittu Power Automaten flowien rakentaminen alkaa olla loppusuoralla. Vain muutamia ominaisuuksia uupuu ja niistäkin aletaan olla hajulla. Kun viimeiset asiat saadaan ratkaistua, jäljellä on enää flowien viilaamista, hienosäätöä ja siistimistä. Sekä tietysti dokumentaatio. Dokumentaatioon saadaan kuitenkin apuja kahdesta jo pidetyistä Power Automate-esityksistä.  Tämänkin viikoinen esitys meni hyvin ja siitä saatiin kuvattua myös materiaalia Mysticonsin somepostausviikolle. 

Tämän lisäksi Power Automateen saatiin lisättyä flowt joilla voidaan poistaa exceliin kerättyjä tietoja ID numeroinnin avulla ja tämän lisäksi Power Automate lähettää henkilölle sähköposti ilmoituksen, kun hänet on lisätty uuteen Teams työtilaan. Vastaavan ilmoituksen työstäminen GitLab repoon liittämisestä on työn alla. 

Kuberneteksessa alkuviikolla painittiin Overflown ympäristön pystyttämisessä ilmenneen ongelman kanssa. Lopulta ongelman aiheuttajaksi paljastui väärä runneri. Group runner ei ollut ratkaisuun sopiva. Kun Group runner otettiin pois päältä, niin ympäristön pystytys sujui ongelmitta. Toinen yllättävä haaste tälle sprintille oli Pengwin Median havaitsema ongelma Kuberneteksen nodejen päivittymisen kanssa. Jostain syystä Kubernetes ei kyennyt päivittämään nodeja uusimpaam deploymenttiin. Tämäkin ongelma saatiin kuitenkin ratkaistua ja nyt Kubernetes päivittää automaattisesti nodet uusimman debloymentin mukaisiksi. 

Tämän lisäksi Kuberneteksessa on painittu tietoturvan ja koventamisen kanssa. Työn alla ovat mm. Policyt ja portti reititykset. Tällä hetkellä Kuben portit ovat toiminnassa 3000+ porteissa, joista toiminnallisuudet olisi tarkoitus saada siirrettyä oikeisiin portteihin. Ympäristön pystytyksessä käytetty skripti on käännetty sprintin aikana myös Ansible playbookiksi. Halutessaan ympäristön voi siis pystyttää nyt joko skriptillä tai playbookin avulla. Tärkeää on huomioida, että kumpaakin käytettäessä käyttäjällä on oltava sudo-oikeudet. Tällä pyritään varmistamaan, että vain valtuutetut käyttäjät hoitavat ympäristön pystytystä. 

Dokumentaation suunnittelu etenee, varsinaista dokumentaatiota aloitetaan seuraavalla sprintillä, koventamisen ja hienosäätämisen jatkuessa. Dokumentaatio pyritään porrastamaan pariin vaiheeseen. Ensin kerätään keskeiset asiat rautalangaksi ja sitten työstetään varsinainen dokumentti puhtaaksi. 

Tavoitteena vielä ratkoa muutamia keskeisiä asioita. Robottia on testattu ja opittu lisää vierailijalta. Nähtäväksi jää saadaanko pipelineihin upotettua testejä ajan puitteissa. Kuten alkusprintistä jo näytti VLE integraatioon paneutumiseen ei aika taida riittää. Tiimi tarkisteli viikon aikana kertyneitä tunteja ja seuraavien sprinttien aikana meillä ei ole yhtään päivää, jolloin kaikki olisivat paikalla täyden päivän. Osalla on tunteja kertynyt niin paljon, että päiviä on lyhennettävä, jotta henkilöt voisivat olla paikalla edes muutaman tunnit joka päivä.  Osalla on puolestaan sovittuja työtehtäviä tai muita menoja, jotka vaikuttavat hankaloittavasti tilanteeseen. Joten tässä tilanteessa on käytettävä jäljellä olevat resurssit järkevästi ja paneuduttava saattamaan nykyiset työn alla olevat asiat jonkinlaiseen fiksuun tilanteeseen, mieluummin kuin aloittamaan uutta.  

Kuumuus ja pitkään jatkunut helle on myös vaikuttanut tilanteeseen. Tiimiläisillä alkavat olla mehut vähissä, kun asuntojen sisälämpötilat huitelevat lähempänä +30 astetta tai sen yli. Vaikka taukoja on pyritty pitämään päivien aikana enemmän ja nestetankkauksesta on huolehdittu jatkuva kuumuus vaikuttaa työtehoon ja keskittymiseen alentavasti. Lisäksi lämpötilat asunnoissa pysyvät yöaikaankin korkeina, joten nukkuminen ja siten palautuminen ovat myös haastavia. Toivottavasti sääennusteet pitävät paikkansa ja ensi viikosta olisi tulossa hieman viileämpi. 
