# Sprint 05

## Pengwin Media

### Sprinttisuunnitelma

Päätimme pidentää sprinttiä kahden viikon pituiseksi (21.6.2021 – 2.7.2021).

- Next.js-projektin perusominaisuudet kuntoon (mm. navigaatio, lokalisaatio, markdown-tiedostojen hyödyntäminen)
- Next.js-projektin perusrakenteen suunnittelu: yksinkertainen rautalankamalli ja kaavio
- Dokumentointi: vaatimusmäärittely, testaussuunnitelma
- wimmalab.org:in sisällön uudistaminen ja laajentaminen Next.js-projektiin, kääntäminen fi/eng (etusivu, opiskelijoille, yrityksille)
- Next.js-projektin visuaalinen suunnittelu Figmassa, brändiuudistuksen jatkokehittäminen
- Iltapäivätoiminnan suunnittelu ja järjestäminen
- Virtuaaliyritysten logojen uudistaminen alulle
- Postauksia mm. yritysvierailijoista sosiaaliseen mediaan


### Sprinttiraportti

- Next.js lokalisaatio saatiin kuntoon, ja tekstejä alettiin lisäillä sivuille. Navigaatiopalkki saatiin paikalleen, mutta se vaatii vielä ulkonäön kehittämistä, kielten pudotusvalikkoa ja mobiilimenua. Sisältöalueen skaalautuva pohjarakenne laitettiin kuntoon.
- Guides-osion perusrakennetta ja sisältöä suunniteltiin, ja yksi ryhmäläinen perehtyi markdown-tiedostojen hyödyntämiseen Next.js-applikaatiossa. Aikaan saatiin demo, jossa md-tiedostojen sisältö käännetään automaattisesti JSX-elementeiksi. Seuraavaksi perehdytään MDX:ään ja arvioidaan, olisiko sen käytölle tarvetta.
- Suunnittelimme sivuston perusrakenteen, ja rautalankamallit edistyivät hyvin. Sisällön perusrakenteet ja tekstisisällöt saatiin lähes kokonaan valmiiksi etusivulle ja opiskelijat-sivulle. Opiskelijat-sivulta puuttuu lähinnä edellisvuosien WIMMALaisten kommentit, joita pyydämme seuraavalla sprintillä. Sosiaalisen median postauksia aiotaan upottaa sivulle, jos se saadaan järkevällä tavalla toteutettua.
- Olemme saaneet tuotettua paljon uutta tekstisisältöä sivuille, samalla kääntäen sitä suomeksi/englanniksi.
- Vaatimusmäärittelyä ja testaussuunnitelmaa kirjoitettiin, ja niistä löytyy nyt tärkeimmät asiat. Emme kokeneet näitä dokumentteja kokonaisuuden kannalta kovin tärkeiksi, koska kyseessä on kuitenkin melko yksinkertainen nettisivu.
- Sivuston visuaalisen ilmeen tarkempi suunnittelu aloitettiin Figmassa, ja valmiiksi saatiin puolet opiskelijat-sivusta. Figma-suunnitelman pohjalta on jo mahdollista alkaa koodaamaan muitakin sivulle tulevia elementtejä. Visuaalinen suunnittelu jatkuu seuraavalla sprintillä.
- Järjestimme torstaina 1.7. iltapäivätoimintaa Lutakossa. Ideana oli geokätköilyn tyylinen arvoitusten ratkaisu jakamiemme vihjeiden perusteella. Tapahtumaa varten kävimme porukalla Lutakon aluetta läpi ja laitoimme ylös mielenkiintoisia paikkoja ja niihin liittyviä arvoituksia.
- Julkaisimme sosiaaliseen mediaan postauksen Pengwin Median iltapäivätoimintaan, Juhon (Logmore) vierailuun sekä tuleviin somepostauksiin liittyen.
- Keskustelimme Mysticonsin kanssa projektin deployaamisesta. Tulimme siihen tulokseen, että projekti olisi kuitenkin tarpeellista laittaa Kubernetekseen, sillä Next.js käyttää sisäänrakennettua NodeJS-serveriä. Projekti saatiinkin jo pyörimään Kuberneteksessa, ja jatkossa deployaamisesta tehdään automaattista.
- Roope (aluksi myös Sari) aloitti adminkäyttöliittymän ja toimeksiantojen lisäyslomakkeen koodaamista Overflow-tiimille. Lomake on pitkä, moniosainen ja paikoittain logiikaltaan monimutkainen, joten validoinnissa sekä tilanhallinnassa on riittänyt haasteita. Sprintin päätteeksi suurimmat haasteet saatiin ratkaistua, ja lomakkeen tyylittely ja muu säätö jatkuu seuraavalla sprintillä.
- Virtuaaliyritysten logojen uudistaminen jätettiin seuraavalle sprintille.
